(in-package :cl-sokoban)

(defmaze
  "    #####          "
  "    #   #          "
  "    #$  #          "
  "  ###  $##         "
  "  #  $ $ #         "
  "### # ## #   ######"
  "#   # ## #####  ..#"
  "# $  $          ..#"
  "##### ### #@##  ..#"
  "    #     #########"
  "    #######        ")

(defmaze
  "############  "
  "#..  #     ###"
  "#..  # $  $  #"
  "#..  #$####  #"
  "#..    @ ##  #"
  "#..  # #  $ ##"
  "###### ##$ $ #"
  "  # $  $ $ $ #"
  "  #    #     #"
  "  ############")

(defmaze
  "        ######## "
  "        #     @# "
  "        # $#$ ## "
  "        # $  $#  "
  "        ##$ $ #  "
  "######### $ # ###"
  "#....  ## $  $  #"
  "##...    $  $   #"
  "#....  ##########"
  "########         ")

(defmaze
  "           ########"
  "           #  ....#"
  "############  ....#"
  "#    #  $ $   ....#"
  "# $$$#$  $ #  ....#"
  "#  $     $ #  ....#"
  "# $$ #$ $ $########"
  "#  $ #     #       "
  "## #########       "
  "#    #    ##       "
  "#     $   ##       "
  "#  $$#$$  @#       "
  "#    #    ##       "
  "###########        ")

(defmaze
  "        #####    "
  "        #   #####"
  "        # #$##  #"
  "        #     $ #"
  "######### ###   #"
  "#....  ## $  $###"
  "#....    $ $$ ## "
  "#....  ##$  $ @# "
  "#########  $  ## "
  "        # $ $  # "
  "        ### ## # "
  "          #    # "
  "          ###### ")

(defmaze
  "######  ### "
  "#..  # ##@##"
  "#..  ###   #"
  "#..     $$ #"
  "#..  # # $ #"
  "#..### # $ #"
  "#### $ #$  #"
  "   #  $# $ #"
  "   # $  $  #"
  "   #  ##   #"
  "   #########")

(defmaze
  "       ##### "
  " #######   ##"
  "## # @## $$ #"
  "#    $      #"
  "#  $  ###   #"
  "### #####$###"
  "# $  ### ..# "
  "# $ $ $ ...# "
  "#    ###...# "
  "# $$ # #...# "
  "#  ### ##### "
  "####         ")

(defmaze
  "  ####          "
  "  #  ###########"
  "  #    $   $ $ #"
  "  # $# $ #  $  #"
  "  #  $ $  #    #"
  "### $# #  #### #"
  "#@#$ $ $  ##   #"
  "#    $ #$#   # #"
  "#   $    $ $ $ #"
  "#####  #########"
  "  #      #      "
  "  #      #      "
  "  #......#      "
  "  #......#      "
  "  #......#      "
  "  ########      ")

(defmaze
  "          #######"
  "          #  ...#"
  "      #####  ...#"
  "      #      . .#"
  "      #  ##  ...#"
  "      ## ##  ...#"
  "     ### ########"
  "     # $$$ ##    "
  " #####  $ $ #####"
  "##   #$ $   #   #"
  "#@ $  $    $  $ #"
  "###### $$ $ #####"
  "     #      #    "
  "     ########    ")

(defmaze
  " ###  #############"
  "##@####       #   #"
  "# $$   $$  $ $ ...#"
  "#  $$$#    $  #...#"
  "# $   # $$ $$ #...#"
  "###   #  $    #...#"
  "#     # $ $ $ #...#"
  "#    ###### ###...#"
  "## #  #  $ $  #...#"
  "#  ## # $$ $ $##..#"
  "# ..# #  $      #.#"
  "# ..# # $$$ $$$ #.#"
  "##### #       # #.#"
  "    # ######### #.#"
  "    #           #.#"
  "    ###############")

(defmaze
  "          ####     "
  "     #### #  #     "
  "   ### @###$ #     "
  "  ##      $  #     "
  " ##  $ $$## ##     "
  " #  #$##     #     "
  " # # $ $$ # ###    "
  " #   $ #  # $ #####"
  "####    #  $$ #   #"
  "#### ## $         #"
  "#.    ###  ########"
  "#.. ..# ####       "
  "#...#.#            "
  "#.....#            "
  "#######            ")

(defmaze
  "################ "
  "#              # "
  "# # ######     # "
  "# #  $ $ $ $#  # "
  "# #   $@$   ## ##"
  "# #  $ $ $###...#"
  "# #   $ $  ##...#"
  "# ###$$$ $ ##...#"
  "#     # ## ##...#"
  "#####   ## ##...#"
  "    #####     ###"
  "        #     #  "
  "        #######  ")

(defmaze
  "   #########       "
  "  ##   ##  ######  "
  "###     #  #    ###"
  "#  $ #$ #  #  ... #"
  "# # $#@$## # #.#. #"
  "#  # #$  #    . . #"
  "# $    $ # # #.#. #"
  "#   ##  ##$ $ . . #"
  "# $ #   #  #$#.#. #"
  "## $  $   $  $... #"
  " #$ ######    ##  #"
  " #  #    ##########"
  " ####              ")

(defmaze
  "       #######    "
  " #######     #    "
  " #     # $@$ #    "
  " #$$ #   #########"
  " # ###......##   #"
  " #   $......## # #"
  " # ###......     #"
  "##   #### ### #$##"
  "#  #$   #  $  # # "
  "#  $ $$$  # $## # "
  "#   $ $ ###$$ # # "
  "#####     $   # # "
  "    ### ###   # # "
  "      #     #   # "
  "      ########  # "
  "             #### ")

(defmaze
  "   ########      "
  "   #   #  #      "
  "   #  $   #      "
  " ### #$   ####   "
  " #  $  ##$   #   "
  " #  # @ $ # $#   "
  " #  #      $ ####"
  " ## ####$##     #"
  " # $#.....# #   #"
  " #  $..*$. $# ###"
  "##  #.....#   #  "
  "#   ### #######  "
  "# $$  #  #       "
  "#  #     #       "
  "######   #       "
  "     #####       ")

(defmaze
  "#####         "
  "#   ##        "
  "#    #  ####  "
  "# $  ####  #  "
  "#  $$ $   $#  "
  "###@ #$    ## "
  " #  ##  $ $ ##"
  " # $  ## ## .#"
  " #  #$##$  #.#"
  " ###   $..##.#"
  "  #    #.*...#"
  "  # $$ #.....#"
  "  #  #########"
  "  #  #        "
  "  ####        ")

(defmaze
  "   ##########   "
  "   #..  #   #   "
  "   #..      #   "
  "   #..  #  #### "
  "  #######  #  ##"
  "  #            #"
  "  #  #  ##  #  #"
  "#### ##  #### ##"
  "#  $  ##### #  #"
  "# # $  $  # $  #"
  "# @$  $   #   ##"
  "#### ## ####### "
  "   #    #       "
  "   ######       ")

(defmaze
  "     ###########   "
  "     #  .  #   #   "
  "     # #.    @ #   "
  " ##### ##..# ####  "
  "##  # ..###     ###"
  "# $ #...   $ #  $ #"
  "#    .. ##  ## ## #"
  "####$##$# $ #   # #"
  "  ## #    #$ $$ # #"
  "  #  $ # #  # $## #"
  "  #               #"
  "  #  ###########  #"
  "  ####         ####")

(defmaze
  "  ######           "
  "  #   @####        "
  "##### $   #        "
  "#   ##    ####     "
  "# $ #  ##    #     "
  "# $ #  ##### #     "
  "## $  $    # #     "
  "## $ $ ### # #     "
  "## #  $  # # #     "
  "## # #$#   # #     "
  "## ###   # # ######"
  "#  $  #### # #....#"
  "#    $    $   ..#.#"
  "####$  $# $   ....#"
  "#       #  ## ....#"
  "###################")

(defmaze
  "    ##########     "
  "#####        ####  "
  "#     #   $  #@ #  "
  "# #######$####  ###"
  "# #    ## #  #$ ..#"
  "# # $     #  #  #.#"
  "# # $  #     #$ ..#"
  "# #  ### ##     #.#"
  "# ###  #  #  #$ ..#"
  "# #    #  ####  #.#"
  "# #$   $  $  #$ ..#"
  "#    $ # $ $ #  #.#"
  "#### $###    #$ ..#"
  "   #    $$ ###....#"
  "   #      ## ######"
  "   ########        ")

(defmaze
  "#########      "
  "#       #      "
  "#       ####   "
  "## #### #  #   "
  "## #@##    #   "
  "# $$$ $  $$#   "
  "#  # ## $  #   "
  "#  # ##  $ ####"
  "####  $$$ $#  #"
  " #   ##   ....#"
  " # #   # #.. .#"
  " #   # # ##...#"
  " ##### $  #...#"
  "     ##   #####"
  "      #####    ")

(defmaze
  "######     ####    "
  "#    #######  #####"
  "#   $#  #  $  #   #"
  "#  $  $  $ # $ $  #"
  "##$ $   # @# $    #"
  "#  $ ########### ##"
  "# #   #.......# $# "
  "# ##  # ......#  # "
  "# #   $........$ # "
  "# # $ #.... ..#  # "
  "#  $ $####$#### $# "
  "# $   ### $   $  ##"
  "# $     $ $  $    #"
  "## ###### $ ##### #"
  "#         #       #"
  "###################")

(defmaze
  "    #######        "
  "    #  #  ####     "
  "##### $#$ #  ##    "
  "#.. #  #  #   #    "
  "#.. # $#$ #  $#### "
  "#.  #     #$  #  # "
  "#..   $#  # $    # "
  "#..@#  #$ #$  #  # "
  "#.. # $#     $#  # "
  "#.. #  #$$#$  #  ##"
  "#.. # $#  #  $#$  #"
  "#.. #  #  #   #   #"
  "##. ####  #####   #"
  " ####  ####   #####")

(defmaze
  "###############    "
  "#..........  .#### "
  "#..........$$.#  # "
  "###########$ #   ##"
  "#      $  $     $ #"
  "## ####   #  $ #  #"
  "#      #   ##  # ##"
  "#  $#  # ##  ### ##"
  "# $ #$###    ### ##"
  "###  $ #  #  ### ##"
  "###    $ ## #  # ##"
  " # $  #  $  $ $   #"
  " #  $  $#$$$  #   #"
  " #  #  $      #####"
  " # @##  #  #  #    "
  " ##############    ")

(defmaze
  "####               "
  "#  ##############  "
  "#  #   ..#......#  "
  "#  # # ##### ...#  "
  "##$#    ........#  "
  "#   ##$######  ####"
  "# $ #     ######@ #"
  "##$ # $   ######  #"
  "#  $ #$$$##       #"
  "#      #    #$#$###"
  "# #### #$$$$$    # "
  "# #    $     #   # "
  "# #   ##        ###"
  "# ######$###### $ #"
  "#        #    #   #"
  "##########    #####")

(defmaze
  " #######       "
  " #  #  #####   "
  "##  #  #...### "
  "#  $#  #...  # "
  "# $ #$$ ...  # "
  "#  $#  #... .# "
  "#   # $########"
  "##$       $ $ #"
  "##  #  $$ #   #"
  " ######  ##$$@#"
  "      #      ##"
  "      ######## ")

(defmaze
  " ################# "
  " #...   #    #   ##"
  "##.....  $## # #$ #"
  "#......#  $  #    #"
  "#......#  #  # #  #"
  "######### $  $ $  #"
  "  #     #$##$ ##$##"
  " ##   $    # $    #"
  " #  ## ### #  ##$ #"
  " # $ $$     $  $  #"
  " # $    $##$ ######"
  " #######  @ ##     "
  "       ######      ")

(defmaze
  "         #####   "
  "     #####   #   "
  "    ## $  $  ####"
  "##### $  $ $ ##.#"
  "#       $$  ##..#"
  "#  ###### ###.. #"
  "## #  #    #... #"
  "# $   #    #... #"
  "#@ #$ ## ####...#"
  "####  $ $$  ##..#"
  "   ##  $ $  $...#"
  "    # $$  $ #  .#"
  "    #   $ $  ####"
  "    ######   #   "
  "         #####   ")

(defmaze
  "#####              "
  "#   ##             "
  "# $  #########     "
  "## # #       ######"
  "## #   $#$#@  #   #"
  "#  #      $ #   $ #"
  "#  ### ######### ##"
  "#  ## ..*..... # ##"
  "## ## *.$..$.$ # ##"
  "# $########## ##$ #"
  "#  $   $  $    $  #"
  "#  #   #   #   #  #"
  "###################")

(defmaze
  "       ########### "
  "       #   #     # "
  "#####  #     $ $ # "
  "#   ##### $## # ## "
  "# $ ##   # ## $  # "
  "# $  @$$ # ##$$$ # "
  "## ###   # ##    # "
  "## #   ### #####$# "
  "## #     $  #....# "
  "#  ### ## $ #....##"
  "# $   $ #   #..$. #"
  "#  ## $ #  ##.... #"
  "#####   ######...##"
  "    #####    ##### ")

(defmaze
  "  ####            "
  "  #  #########    "
  " ##  ##  #   #    "
  " #  $# $@$   #### "
  " #$  $  # $ $#  ##"
  "##  $## #$ $     #"
  "#  #  # #   $$$  #"
  "# $    $  $## ####"
  "# $ $ #$#  #  #   "
  "##  ###  ###$ #   "
  " #  #....     #   "
  " ####......####   "
  "   #....####      "
  "   #...##         "
  "   #...#          "
  "   #####          ")

(defmaze
  "      ####   "
  "  #####  #   "
  " ##     $#   "
  "## $  ## ### "
  "#@$ $ # $  # "
  "#### ##   $# "
  " #....#$ $ # "
  " #....#   $# "
  " #....  $$ ##"
  " #... # $   #"
  " ######$ $  #"
  "      #   ###"
  "      #$ ### "
  "      #  #   "
  "      ####   ")

(defmaze
  "############"
  "##     ##  #"
  "##   $   $ #"
  "#### ## $$ #"
  "#   $ #    #"
  "# $$$ # ####"
  "#   # # $ ##"
  "#  #  #  $ #"
  "# $# $#    #"
  "#   ..# ####"
  "####.. $ #@#"
  "#.....# $# #"
  "##....#  $ #"
  "###..##    #"
  "############")

(defmaze
  " #########    "
  " #....   ##   "
  " #.#.#  $ ##  "
  "##....# # @## "
  "# ....#  #  ##"
  "#     #$ ##$ #"
  "## ###  $    #"
  " #$  $ $ $#  #"
  " # #  $ $ ## #"
  " #  ###  ##  #"
  " #    ## ## ##"
  " #  $ #  $  # "
  " ###$ $   ### "
  "   #  #####   "
  "   ####       ")

(defmaze
  "############ ######"
  "#   #    # ###....#"
  "#   $$#   @  .....#"
  "#   # ###   # ....#"
  "## ## ###  #  ....#"
  " # $ $     # # ####"
  " #  $ $##  #      #"
  "#### #  #### # ## #"
  "#  # #$   ## #    #"
  "# $  $  # ## #   ##"
  "# # $ $    # #   # "
  "#  $ ## ## # ##### "
  "# $$     $$  #     "
  "## ## ### $  #     "
  " #    # #    #     "
  " ###### ######     ")

(defmaze
  "            #####  "
  "#####  ######   #  "
  "#   ####  $ $ $ #  "
  "# $   ## ## ##  ## "
  "#   $ $     $  $ # "
  "### $  ## ##     ##"
  "  # ##### #####$$ #"
  " ##$##### @##     #"
  " # $  ###$### $  ##"
  " # $  #   ###  ### "
  " # $$ $ #   $$ #   "
  " #     #   ##  #   "
  " #######.. .###    "
  "    #.........#    "
  "    #.........#    "
  "    ###########    ")

(defmaze
  "###########        "
  "#......   #########"
  "#......   #  ##   #"
  "#..### $    $     #"
  "#... $ $ #   ##   #"
  "#...#$#####    #  #"
  "###    #   #$  #$ #"
  "  #  $$ $ $  $##  #"
  "  #  $   #$#$ ##$ #"
  "  ### ## #    ##  #"
  "   #  $ $ ## ######"
  "   #    $  $  #    "
  "   ##   # #   #    "
  "    #####@#####    "
  "        ###        ")

(defmaze
  "      #### "
  "####### @# "
  "#     $  # "
  "#   $## $# "
  "##$#...# # "
  " # $...  # "
  " # #. .# ##"
  " #   # #$ #"
  " #$  $    #"
  " #  #######"
  " ####      ")

(defmaze
  "             ######"
  " #############....#"
  "##   ##     ##....#"
  "#  $$##  $ @##....#"
  "#      $$ $#  ....#"
  "#  $ ## $$ # # ...#"
  "#  $ ## $  #  ....#"
  "## ##### ### ##.###"
  "##   $  $ ##   .  #"
  "# $###  # ##### ###"
  "#   $   #       #  "
  "#  $ #$ $ $###  #  "
  "# $$$# $   # ####  "
  "#    #  $$ #       "
  "######   ###       "
  "     #####         ")

(defmaze
  "    ############ "
  "    #          ##"
  "    #  # #$$ $  #"
  "    #$ #$#  ## @#"
  "   ## ## # $ # ##"
  "   #   $ #$  # # "
  "   #   # $   # # "
  "   ## $ $   ## # "
  "   #  #  ##  $ # "
  "   #    ## $$# # "
  "######$$   #   # "
  "#....#  ######## "
  "#.#... ##        "
  "#....   #        "
  "#....   #        "
  "#########        ")

(defmaze
  "           #####   "
  "          ##   ##  "
  "         ##     #  "
  "        ##  $$  #  "
  "       ## $$  $ #  "
  "       # $    $ #  "
  "####   #   $$ #####"
  "#  ######## ##    #"
  "#.            $$$@#"
  "#.# ####### ##   ##"
  "#.# #######. #$ $##"
  "#........... #    #"
  "##############  $ #"
  "             ##  ##"
  "              #### ")

(defmaze
  "     ########     "
  "  ####      ######"
  "  #    ## $ $   @#"
  "  # ## ##$#$ $ $##"
  "### ......#  $$ ##"
  "#   ......#  #   #"
  "# # ......#$  $  #"
  "# #$...... $$# $ #"
  "#   ### ###$  $ ##"
  "###  $  $  $  $ # "
  "  #  $  $  $  $ # "
  "  ######   ###### "
  "       #####      ")

(defmaze
  "        #######    "
  "    #####  #  #### "
  "    #   #   $    # "
  " #### #$$ ## ##  # "
  "##      # #  ## ###"
  "#  ### $#$  $  $  #"
  "#...    # ##  #   #"
  "#...#    @ # ### ##"
  "#...#  ###  $  $  #"
  "######## ##   #   #"
  "          #########")

(defmaze
  " #####             "
  " #   #             "
  " # # #######       "
  " #      $@######   "
  " # $ ##$ ###   #   "
  " # #### $    $ #   "
  " # ##### #  #$ ####"
  "##  #### ##$      #"
  "#  $#  $  # ## ## #"
  "#         # #...# #"
  "######  ###  ...  #"
  "     #### # #...# #"
  "          # ### # #"
  "          #       #"
  "          #########")

(defmaze
  "##### ####      "
  "#...# #  ####   "
  "#...###  $  #   "
  "#....## $  $### "
  "##....##   $  # "
  "###... ## $ $ # "
  "# ##    #  $  # "
  "#  ## # ### ####"
  "# $ # #$  $    #"
  "#  $ @ $    $  #"
  "#   # $ $$ $ ###"
  "#  ######  ###  "
  "# ##    ####    "
  "###             ")

(defmaze
  "##########    "
  "#        #### "
  "# ###### #  ##"
  "# # $ $ $  $ #"
  "#       #$   #"
  "###$  $$#  ###"
  "  #  ## # $## "
  "  ##$#   $ @# "
  "   #  $ $ ### "
  "   # #   $  # "
  "   # ##   # # "
  "  ##  ##### # "
  "  #         # "
  "  #.......### "
  "  #.......#   "
  "  #########   ")

(defmaze
  "         ####     "
  " #########  ##    "
  "##  $      $ #####"
  "#   ## ##   ##...#"
  "# #$$ $ $$#$##...#"
  "# #   @   #   ...#"
  "#  $# ###$$   ...#"
  "# $  $$  $ ##....#"
  "###$       #######"
  "  #  #######      "
  "  ####            ")

(defmaze
  "  #########  "
  "  #*.$#$.$#  "
  "  #.*.$.$.#  "
  "  #*.$.$.$#  "
  "  #.*.$.$.#  "
  "  #*.$.$.$#  "
  "  ###   ###  "
  "    #   #    "
  "###### ######"
  "#           #"
  "# $ $ $ $ $ #"
  "## $ $ $ $ ##"
  " #$ $ $ $ $# "
  " #   $@$   # "
  " #  #####  # "
  " ####   #### ")

(defmaze
  "       ####     "
  "       #  ##    "
  "       #   ##   "
  "       # $$ ##  "
  "     ###$  $ ## "
  "  ####    $   # "
  "###  # #####  # "
  "#    # #....$ # "
  "# #   $ ....# # "
  "#  $ # #.*..# # "
  "###  #### ### # "
  "  #### @$  ##$##"
  "     ### $     #"
  "       #  ##   #"
  "       #########")

(defmaze
  "      ############ "
  "     ##..    #   # "
  "    ##..* $    $ # "
  "   ##..*.# # # $## "
  "   #..*.# # # $  # "
  "####...#  #    # # "
  "#  ## #          # "
  "# @$ $ ###  #   ## "
  "# $   $   # #   #  "
  "###$$   # # # # #  "
  "  #   $   # # #####"
  "  # $# #####      #"
  "  #$   #   #    # #"
  "  #  ###   ##     #"
  "  #  #      #    ##"
  "  ####      ###### ")



(setf *mazes* (nreverse *mazes*))
